const OracleService = require('../service/OracleService');

class updaterProdutosModel 
{  
  getUpdaterProdutos(isActive = false) {
    let sql = `
      SELECT ID, NMPRODUCT, IDUTMULTVER
        FROM UPDATERPRODUTOS
    `;
    if(isActive) {
      sql = `${sql} WHERE IDATIVO = 'S'`;
    }
    return OracleService.fetchAssoc(sql);
  }

  getUpdaterProdutosById(id) {
    const sql = `
      SELECT ID, NMPRODUCT, IDUTMULTVER
        FROM UPDATERPRODUTOS
       WHERE ID = :ID
    `;

    const params = {
      ID: id,
    }
    
    return OracleService.fetchAssoc(sql, params);
  }

  getUpdaterProdutosWithUnits(id) {
    const sql = `
    SELECT PF.ID AS PRODFILIID, PF.CDFILIAL || ' - ' || F.NMFILIAL AS FILIAL, PF.CDFILIAL, F.NMFILIAL,
           E.SGESTADO, P.NMPRODUCT, P.IDUTMULTVER, P.ID,
           DECODE(PF.NRVERSAOATUAL, NULL, 'S', 'N') AS IDINSTPEND,
           CASE WHEN PF.NRVERSAOATUAL IS NULL AND EV.IDSTEVENTO IS NULL
                THEN 'INSTALACAO_PENDENTE'
                ELSE EV.IDSTEVENTO
            END AS IDSTEVENTO,
           DECODE(PF.NRVERSAOATUAL, NULL, '-', PF.NRVERSAOATUAL) AS NRVERSAOATUAL
      FROM UPDATERPRODUTOS P
      JOIN UPDATERPRODFILI PF ON PF.UPDATERPRODID = P.ID
 LEFT JOIN FILIAL F ON PF.CDFILIAL = F.CDFILIAL 
 LEFT JOIN ENDEFILI E ON E.CDFILIAL = F.CDFILIAL
                     AND E.IDTPENDEFILI = 'P'
 LEFT JOIN UPDATEREVENTOS EV ON EV.CDPRODUCTID = P.ID
                            AND EV.CDFILIAL = PF.CDFILIAL
                            AND EV.IDSTEVENTO NOT IN ('FINALIZADO', 'CANCELADO')
     WHERE P.ID = :ID
  ORDER BY F.CDFILIAL ASC
    `;

    const params = {
      ID: id,
    }
    
    return OracleService.fetchAssoc(sql, params);
  }

  insertUpdaterProdutos(params) {
    const sql = `
      INSERT INTO UPDATERPRODUTOS
                ( ID,  NMPRODUCT,  IDUTMULTVER, DTINCLUSAO, DTULTATU)
         VALUES (:ID, :NMPRODUCT, :IDUTMULTVER, SYSDATE,    SYSDATE)
    `;
    return OracleService.execute(sql, params);
  }

  updateUpdaterProdutos(params) {
    const sql = `
      UPDATE UPDATERPRODUTOS
         SET NMPRODUCT   = :NMPRODUCT,
             IDUTMULTVER = :IDUTMULTVER,
             IDATIVO     = 'S',
             DTULTATU    = SYSDATE
       WHERE ID = :ID
    `;
    return OracleService.execute(sql, params);
  }

  inactiveUpdaterProdutos(id) {
    const sql = `
      UPDATE UPDATERPRODUTOS
         SET IDATIVO  = 'N',
             DTULTATU = SYSDATE
       WHERE ID = :ID
    `;

    const params = {
      ID: id
    }

    return OracleService.execute(sql, params);
  }
}

module.exports = new updaterProdutosModel();
